//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PGMPDecryptorChild_h
#define PGMPDecryptorChild_h

#include "mozilla/gmp/PGMPDecryptor.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "gmp-decryption.h"
#include "gmp-errors.h"

namespace mozilla {
namespace gmp {
class PGMPContentChild;
} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace gmp {
class PGMPContentParent;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class PGMPContentChild;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {


class PGMPDecryptorChild :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::gmp::PGMPContentChild;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::gmp::CDMInputBuffer CDMInputBuffer;
    typedef mozilla::gmp::CDMKeyInformation CDMKeyInformation;
    typedef mozilla::gmp::CDMVideoDecoderConfig CDMVideoDecoderConfig;
    typedef mozilla::gmp::CDMVideoFrame CDMVideoFrame;
    typedef mozilla::gmp::CDMVideoPlane CDMVideoPlane;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::gmp::GMPDecryptionData GMPDecryptionData;
    typedef mozilla::gmp::GMPKeyInformation GMPKeyInformation;
    typedef mozilla::gmp::GMPPlaneData GMPPlaneData;
    typedef mozilla::gmp::GMPVideoEncodedFrameData GMPVideoEncodedFrameData;
    typedef mozilla::gmp::GMPVideoi420FrameData GMPVideoi420FrameData;
    typedef mozilla::gmp::NodeIdData NodeIdData;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::PromiseRejectReason PromiseRejectReason;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::gmp::PGMPContentChild PGMPContentChild;
    typedef mozilla::gmp::PGMPContentParent PGMPContentParent;

    typedef PGMPDecryptor::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvInit(
            const bool& aDistinctiveIdentifierRequired,
            const bool& aPersistentStateRequired) = 0;
    virtual mozilla::ipc::IPCResult
    RecvCreateSession(
            const uint32_t& aCreateSessionToken,
            const uint32_t& aPromiseId,
            const nsCString& aInitDataType,
            nsTArray<uint8_t>&& aInitData,
            const GMPSessionType& aSessionType) = 0;
    virtual mozilla::ipc::IPCResult
    RecvLoadSession(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvUpdateSession(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId,
            nsTArray<uint8_t>&& aResponse) = 0;
    virtual mozilla::ipc::IPCResult
    RecvCloseSession(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvRemoveSession(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvSetServerCertificate(
            const uint32_t& aPromiseId,
            nsTArray<uint8_t>&& aServerCert) = 0;
    virtual mozilla::ipc::IPCResult
    RecvDecrypt(
            const uint32_t& aId,
            nsTArray<uint8_t>&& aBuffer,
            const GMPDecryptionData& aMetadata) = 0;
    virtual mozilla::ipc::IPCResult
    RecvDecryptingComplete() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PGMPDecryptorChild();

    virtual ~PGMPDecryptorChild();

    PGMPContentChild*
    Manager() const;

    static bool
    Send__delete__(PGMPDecryptorChild* actor);

    bool
    SendSetDecryptorId(const uint32_t& aId);

    bool
    SendSetSessionId(
            const uint32_t& aCreateSessionToken,
            const nsCString& aSessionId);

    bool
    SendResolveLoadSessionPromise(
            const uint32_t& aPromiseId,
            const bool& aSuccess);

    bool
    SendResolvePromise(const uint32_t& aPromiseId);

    bool
    SendRejectPromise(
            const uint32_t& aPromiseId,
            const GMPDOMException& aDOMExceptionCode,
            const nsCString& aMessage);

    bool
    SendSessionMessage(
            const nsCString& aSessionId,
            const GMPSessionMessageType& aMessageType,
            const nsTArray<uint8_t>& aMessage);

    bool
    SendExpirationChange(
            const nsCString& aSessionId,
            const double& aExpiryTime);

    bool
    SendSessionClosed(const nsCString& aSessionId);

    bool
    SendSessionError(
            const nsCString& aSessionId,
            const GMPDOMException& aDOMExceptionCode,
            const uint32_t& aSystemCode,
            const nsCString& aMessage);

    bool
    SendDecrypted(
            const uint32_t& aId,
            const GMPErr& aResult,
            const nsTArray<uint8_t>& aBuffer);

    bool
    SendShutdown();

    bool
    SendBatchedKeyStatusChanged(
            const nsCString& aSessionId,
            const nsTArray<GMPKeyInformation>& aKeyInfos);

    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const GMPDecryptionData& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            GMPDecryptionData* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const nsTArray<GMPKeyInformation>& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            nsTArray<GMPKeyInformation>* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const GMPKeyInformation& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            GMPKeyInformation* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const PGMPDecryptorChild* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PGMPDecryptorChild** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    State mState;
};


} // namespace gmp
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace gmp {
class GMPDecryptorChild :
    public PGMPDecryptorChild
{
    virtual mozilla::ipc::IPCResult
    RecvInit(
            const bool& aDistinctiveIdentifierRequired,
            const bool& aPersistentStateRequired);

    virtual mozilla::ipc::IPCResult
    RecvCreateSession(
            const uint32_t& aCreateSessionToken,
            const uint32_t& aPromiseId,
            const nsCString& aInitDataType,
            nsTArray<uint8_t>&& aInitData,
            const GMPSessionType& aSessionType);

    virtual mozilla::ipc::IPCResult
    RecvLoadSession(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId);

    virtual mozilla::ipc::IPCResult
    RecvUpdateSession(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId,
            nsTArray<uint8_t>&& aResponse);

    virtual mozilla::ipc::IPCResult
    RecvCloseSession(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId);

    virtual mozilla::ipc::IPCResult
    RecvRemoveSession(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId);

    virtual mozilla::ipc::IPCResult
    RecvSetServerCertificate(
            const uint32_t& aPromiseId,
            nsTArray<uint8_t>&& aServerCert);

    virtual mozilla::ipc::IPCResult
    RecvDecrypt(
            const uint32_t& aId,
            nsTArray<uint8_t>&& aBuffer,
            const GMPDecryptionData& aMetadata);

    virtual mozilla::ipc::IPCResult
    RecvDecryptingComplete();

    MOZ_IMPLICIT GMPDecryptorChild();
    virtual ~GMPDecryptorChild();
};
} // namespace gmp
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace gmp {
mozilla::ipc::IPCResult
GMPDecryptorChild::RecvInit(
        const bool& aDistinctiveIdentifierRequired,
        const bool& aPersistentStateRequired)
{
}

mozilla::ipc::IPCResult
GMPDecryptorChild::RecvCreateSession(
        const uint32_t& aCreateSessionToken,
        const uint32_t& aPromiseId,
        const nsCString& aInitDataType,
        nsTArray<uint8_t>&& aInitData,
        const GMPSessionType& aSessionType)
{
}

mozilla::ipc::IPCResult
GMPDecryptorChild::RecvLoadSession(
        const uint32_t& aPromiseId,
        const nsCString& aSessionId)
{
}

mozilla::ipc::IPCResult
GMPDecryptorChild::RecvUpdateSession(
        const uint32_t& aPromiseId,
        const nsCString& aSessionId,
        nsTArray<uint8_t>&& aResponse)
{
}

mozilla::ipc::IPCResult
GMPDecryptorChild::RecvCloseSession(
        const uint32_t& aPromiseId,
        const nsCString& aSessionId)
{
}

mozilla::ipc::IPCResult
GMPDecryptorChild::RecvRemoveSession(
        const uint32_t& aPromiseId,
        const nsCString& aSessionId)
{
}

mozilla::ipc::IPCResult
GMPDecryptorChild::RecvSetServerCertificate(
        const uint32_t& aPromiseId,
        nsTArray<uint8_t>&& aServerCert)
{
}

mozilla::ipc::IPCResult
GMPDecryptorChild::RecvDecrypt(
        const uint32_t& aId,
        nsTArray<uint8_t>&& aBuffer,
        const GMPDecryptionData& aMetadata)
{
}

mozilla::ipc::IPCResult
GMPDecryptorChild::RecvDecryptingComplete()
{
}

MOZ_IMPLICIT GMPDecryptorChild::GMPDecryptorChild()
{
    MOZ_COUNT_CTOR(GMPDecryptorChild);
}

MOZ_IMPLICIT GMPDecryptorChild::~GMPDecryptorChild()
{
    MOZ_COUNT_DTOR(GMPDecryptorChild);
}

} // namespace gmp
} // namespace mozilla
#endif // if 0

#endif // ifndef PGMPDecryptorChild_h
