//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PHal_h
#define PHal_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "mozilla/HalSensor.h"
#include "mozilla/HalTypes.h"
#include "mozilla/dom/ScreenOrientation.h"
#include "nsRect.h"
#include "prtime.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct BatteryInformation|
//
namespace mozilla {
namespace hal {
class BatteryInformation final
{
private:

public:
    MOZ_IMPLICIT BatteryInformation();

    MOZ_IMPLICIT BatteryInformation(
            const double& _level,
            const bool& _charging,
            const double& _remainingTime)
    {
        Init();
        Assign(_level, _charging, _remainingTime);
    }

    MOZ_IMPLICIT BatteryInformation(const BatteryInformation& _o)
    {
        Init();
        Assign((_o).level(), (_o).charging(), (_o).remainingTime());
    }

    ~BatteryInformation();

    void
    operator=(const BatteryInformation& _o)
    {
        Assign((_o).level(), (_o).charging(), (_o).remainingTime());
    }

    bool
    operator==(const BatteryInformation& _o) const;

    bool
    operator!=(const BatteryInformation& _o) const;

    double&
    level()
    {
        return level_;
    }
    const double&
    level() const
    {
        return level_;
    }

    bool&
    charging()
    {
        return charging_;
    }
    const bool&
    charging() const
    {
        return charging_;
    }

    double&
    remainingTime()
    {
        return remainingTime_;
    }
    const double&
    remainingTime() const
    {
        return remainingTime_;
    }

private:
    void
    Init();

    void
    Assign(
            const double& _level,
            const bool& _charging,
            const double& _remainingTime);

    double level_;
    bool charging_;
    double remainingTime_;
};
} // namespace hal
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SensorData|
//
namespace mozilla {
namespace hal {
class SensorData final
{
private:
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::SensorAccuracyType SensorAccuracyType;

public:
    MOZ_IMPLICIT SensorData();

    MOZ_IMPLICIT SensorData(
            const SensorType& _sensor,
            const PRTime& _timestamp,
            const nsTArray<float>& _values,
            const SensorAccuracyType& _accuracy)
    {
        Init();
        Assign(_sensor, _timestamp, _values, _accuracy);
    }

    MOZ_IMPLICIT SensorData(const SensorData& _o)
    {
        Init();
        Assign((_o).sensor(), (_o).timestamp(), (_o).values(), (_o).accuracy());
    }

    ~SensorData();

    void
    operator=(const SensorData& _o)
    {
        Assign((_o).sensor(), (_o).timestamp(), (_o).values(), (_o).accuracy());
    }

    bool
    operator==(const SensorData& _o) const;

    bool
    operator!=(const SensorData& _o) const;

    SensorType&
    sensor()
    {
        return sensor_;
    }
    const SensorType&
    sensor() const
    {
        return sensor_;
    }

    PRTime&
    timestamp()
    {
        return timestamp_;
    }
    const PRTime&
    timestamp() const
    {
        return timestamp_;
    }

    nsTArray<float>&
    values()
    {
        return values_;
    }
    const nsTArray<float>&
    values() const
    {
        return values_;
    }

    SensorAccuracyType&
    accuracy()
    {
        return accuracy_;
    }
    const SensorAccuracyType&
    accuracy() const
    {
        return accuracy_;
    }

private:
    void
    Init();

    void
    Assign(
            const SensorType& _sensor,
            const PRTime& _timestamp,
            const nsTArray<float>& _values,
            const SensorAccuracyType& _accuracy);

    SensorType sensor_;
    PRTime timestamp_;
    nsTArray<float> values_;
    SensorAccuracyType accuracy_;
};
} // namespace hal
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct NetworkInformation|
//
namespace mozilla {
namespace hal {
class NetworkInformation final
{
private:

public:
    MOZ_IMPLICIT NetworkInformation();

    MOZ_IMPLICIT NetworkInformation(
            const uint32_t& _type,
            const bool& _isWifi,
            const uint32_t& _dhcpGateway)
    {
        Init();
        Assign(_type, _isWifi, _dhcpGateway);
    }

    MOZ_IMPLICIT NetworkInformation(const NetworkInformation& _o)
    {
        Init();
        Assign((_o).type(), (_o).isWifi(), (_o).dhcpGateway());
    }

    ~NetworkInformation();

    void
    operator=(const NetworkInformation& _o)
    {
        Assign((_o).type(), (_o).isWifi(), (_o).dhcpGateway());
    }

    bool
    operator==(const NetworkInformation& _o) const;

    bool
    operator!=(const NetworkInformation& _o) const;

    uint32_t&
    type()
    {
        return type_;
    }
    const uint32_t&
    type() const
    {
        return type_;
    }

    bool&
    isWifi()
    {
        return isWifi_;
    }
    const bool&
    isWifi() const
    {
        return isWifi_;
    }

    uint32_t&
    dhcpGateway()
    {
        return dhcpGateway_;
    }
    const uint32_t&
    dhcpGateway() const
    {
        return dhcpGateway_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint32_t& _type,
            const bool& _isWifi,
            const uint32_t& _dhcpGateway);

    uint32_t type_;
    bool isWifi_;
    uint32_t dhcpGateway_;
};
} // namespace hal
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SwitchEvent|
//
namespace mozilla {
namespace hal {
class SwitchEvent final
{
private:
    typedef mozilla::hal::SwitchDevice SwitchDevice;
    typedef mozilla::hal::SwitchState SwitchState;

public:
    MOZ_IMPLICIT SwitchEvent();

    MOZ_IMPLICIT SwitchEvent(
            const SwitchDevice& _device,
            const SwitchState& _status)
    {
        Init();
        Assign(_device, _status);
    }

    MOZ_IMPLICIT SwitchEvent(const SwitchEvent& _o)
    {
        Init();
        Assign((_o).device(), (_o).status());
    }

    ~SwitchEvent();

    void
    operator=(const SwitchEvent& _o)
    {
        Assign((_o).device(), (_o).status());
    }

    bool
    operator==(const SwitchEvent& _o) const;

    bool
    operator!=(const SwitchEvent& _o) const;

    SwitchDevice&
    device()
    {
        return device_;
    }
    const SwitchDevice&
    device() const
    {
        return device_;
    }

    SwitchState&
    status()
    {
        return status_;
    }
    const SwitchState&
    status() const
    {
        return status_;
    }

private:
    void
    Init();

    void
    Assign(
            const SwitchDevice& _device,
            const SwitchState& _status);

    SwitchDevice device_;
    SwitchState status_;
};
} // namespace hal
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct WakeLockInformation|
//
namespace mozilla {
namespace hal {
class WakeLockInformation final
{
private:

public:
    MOZ_IMPLICIT WakeLockInformation();

    MOZ_IMPLICIT WakeLockInformation(
            const nsString& _topic,
            const uint32_t& _numLocks,
            const uint32_t& _numHidden,
            const nsTArray<uint64_t>& _lockingProcesses)
    {
        Init();
        Assign(_topic, _numLocks, _numHidden, _lockingProcesses);
    }

    MOZ_IMPLICIT WakeLockInformation(const WakeLockInformation& _o)
    {
        Init();
        Assign((_o).topic(), (_o).numLocks(), (_o).numHidden(), (_o).lockingProcesses());
    }

    ~WakeLockInformation();

    void
    operator=(const WakeLockInformation& _o)
    {
        Assign((_o).topic(), (_o).numLocks(), (_o).numHidden(), (_o).lockingProcesses());
    }

    bool
    operator==(const WakeLockInformation& _o) const;

    bool
    operator!=(const WakeLockInformation& _o) const;

    nsString&
    topic()
    {
        return topic_;
    }
    const nsString&
    topic() const
    {
        return topic_;
    }

    uint32_t&
    numLocks()
    {
        return numLocks_;
    }
    const uint32_t&
    numLocks() const
    {
        return numLocks_;
    }

    uint32_t&
    numHidden()
    {
        return numHidden_;
    }
    const uint32_t&
    numHidden() const
    {
        return numHidden_;
    }

    nsTArray<uint64_t>&
    lockingProcesses()
    {
        return lockingProcesses_;
    }
    const nsTArray<uint64_t>&
    lockingProcesses() const
    {
        return lockingProcesses_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _topic,
            const uint32_t& _numLocks,
            const uint32_t& _numHidden,
            const nsTArray<uint64_t>& _lockingProcesses);

    nsString topic_;
    uint32_t numLocks_;
    uint32_t numHidden_;
    nsTArray<uint64_t> lockingProcesses_;
};
} // namespace hal
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ScreenConfiguration|
//
namespace mozilla {
namespace hal {
class ScreenConfiguration final
{
private:
    typedef mozilla::dom::ScreenOrientationInternal ScreenOrientationInternal;

public:
    MOZ_IMPLICIT ScreenConfiguration();

    MOZ_IMPLICIT ScreenConfiguration(
            const nsIntRect& _rect,
            const ScreenOrientationInternal& _orientation,
            const uint16_t& _angle,
            const uint32_t& _colorDepth,
            const uint32_t& _pixelDepth)
    {
        Init();
        Assign(_rect, _orientation, _angle, _colorDepth, _pixelDepth);
    }

    MOZ_IMPLICIT ScreenConfiguration(const ScreenConfiguration& _o)
    {
        Init();
        Assign((_o).rect(), (_o).orientation(), (_o).angle(), (_o).colorDepth(), (_o).pixelDepth());
    }

    ~ScreenConfiguration();

    void
    operator=(const ScreenConfiguration& _o)
    {
        Assign((_o).rect(), (_o).orientation(), (_o).angle(), (_o).colorDepth(), (_o).pixelDepth());
    }

    bool
    operator==(const ScreenConfiguration& _o) const;

    bool
    operator!=(const ScreenConfiguration& _o) const;

    nsIntRect&
    rect()
    {
        return rect_;
    }
    const nsIntRect&
    rect() const
    {
        return rect_;
    }

    ScreenOrientationInternal&
    orientation()
    {
        return orientation_;
    }
    const ScreenOrientationInternal&
    orientation() const
    {
        return orientation_;
    }

    uint16_t&
    angle()
    {
        return angle_;
    }
    const uint16_t&
    angle() const
    {
        return angle_;
    }

    uint32_t&
    colorDepth()
    {
        return colorDepth_;
    }
    const uint32_t&
    colorDepth() const
    {
        return colorDepth_;
    }

    uint32_t&
    pixelDepth()
    {
        return pixelDepth_;
    }
    const uint32_t&
    pixelDepth() const
    {
        return pixelDepth_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsIntRect& _rect,
            const ScreenOrientationInternal& _orientation,
            const uint16_t& _angle,
            const uint32_t& _colorDepth,
            const uint32_t& _pixelDepth);

    nsIntRect rect_;
    ScreenOrientationInternal orientation_;
    uint16_t angle_;
    uint32_t colorDepth_;
    uint32_t pixelDepth_;
};
} // namespace hal
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SystemTimezoneChangeInformation|
//
namespace mozilla {
namespace hal {
class SystemTimezoneChangeInformation final
{
private:

public:
    MOZ_IMPLICIT SystemTimezoneChangeInformation();

    MOZ_IMPLICIT SystemTimezoneChangeInformation(
            const int32_t& _oldTimezoneOffsetMinutes,
            const int32_t& _newTimezoneOffsetMinutes)
    {
        Init();
        Assign(_oldTimezoneOffsetMinutes, _newTimezoneOffsetMinutes);
    }

    MOZ_IMPLICIT SystemTimezoneChangeInformation(const SystemTimezoneChangeInformation& _o)
    {
        Init();
        Assign((_o).oldTimezoneOffsetMinutes(), (_o).newTimezoneOffsetMinutes());
    }

    ~SystemTimezoneChangeInformation();

    void
    operator=(const SystemTimezoneChangeInformation& _o)
    {
        Assign((_o).oldTimezoneOffsetMinutes(), (_o).newTimezoneOffsetMinutes());
    }

    bool
    operator==(const SystemTimezoneChangeInformation& _o) const;

    bool
    operator!=(const SystemTimezoneChangeInformation& _o) const;

    int32_t&
    oldTimezoneOffsetMinutes()
    {
        return oldTimezoneOffsetMinutes_;
    }
    const int32_t&
    oldTimezoneOffsetMinutes() const
    {
        return oldTimezoneOffsetMinutes_;
    }

    int32_t&
    newTimezoneOffsetMinutes()
    {
        return newTimezoneOffsetMinutes_;
    }
    const int32_t&
    newTimezoneOffsetMinutes() const
    {
        return newTimezoneOffsetMinutes_;
    }

private:
    void
    Init();

    void
    Assign(
            const int32_t& _oldTimezoneOffsetMinutes,
            const int32_t& _newTimezoneOffsetMinutes);

    int32_t oldTimezoneOffsetMinutes_;
    int32_t newTimezoneOffsetMinutes_;
};
} // namespace hal
} // namespace mozilla

namespace mozilla {
namespace hal_sandbox {
class PHalParent;
} // namespace hal_sandbox
} // namespace mozilla
namespace mozilla {
namespace hal_sandbox {
class PHalChild;
} // namespace hal_sandbox
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PHalChild and PHalParent
//
namespace mozilla {
namespace hal_sandbox {
namespace PHal {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::hal_sandbox::PHalParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::hal_sandbox::PHalChild>* aChild);

enum State {
    __Dead,
    __Null,
    __Start = __Null
};

enum MessageType {
    PHalStart = PHalMsgStart << 16,
    Msg_NotifyBatteryChange__ID,
    Msg_NotifyNetworkChange__ID,
    Msg_NotifyWakeLockChange__ID,
    Msg_NotifyScreenConfigurationChange__ID,
    Msg_NotifySwitchChange__ID,
    Msg_NotifySystemClockChange__ID,
    Msg_NotifySystemTimezoneChange__ID,
    Msg_Vibrate__ID,
    Msg_CancelVibrate__ID,
    Msg_EnableBatteryNotifications__ID,
    Msg_DisableBatteryNotifications__ID,
    Msg_GetCurrentBatteryInformation__ID,
    Reply_GetCurrentBatteryInformation__ID,
    Msg_EnableNetworkNotifications__ID,
    Msg_DisableNetworkNotifications__ID,
    Msg_GetCurrentNetworkInformation__ID,
    Reply_GetCurrentNetworkInformation__ID,
    Msg_AdjustSystemClock__ID,
    Msg_EnableSystemClockChangeNotifications__ID,
    Msg_DisableSystemClockChangeNotifications__ID,
    Msg_EnableSystemTimezoneChangeNotifications__ID,
    Msg_DisableSystemTimezoneChangeNotifications__ID,
    Msg_ModifyWakeLock__ID,
    Msg_EnableWakeLockNotifications__ID,
    Msg_DisableWakeLockNotifications__ID,
    Msg_GetWakeLockInfo__ID,
    Reply_GetWakeLockInfo__ID,
    Msg_EnableScreenConfigurationNotifications__ID,
    Msg_DisableScreenConfigurationNotifications__ID,
    Msg_LockScreenOrientation__ID,
    Reply_LockScreenOrientation__ID,
    Msg_UnlockScreenOrientation__ID,
    Msg_EnableSwitchNotifications__ID,
    Msg_DisableSwitchNotifications__ID,
    Msg_NotifySensorChange__ID,
    Msg_EnableSensorNotifications__ID,
    Msg_DisableSensorNotifications__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    PHalEnd
};

void
Transition(
        MessageType msg,
        State* next);

IPC::Message*
Msg_NotifyBatteryChange(int32_t routingId);

IPC::Message*
Msg_NotifyNetworkChange(int32_t routingId);

IPC::Message*
Msg_NotifyWakeLockChange(int32_t routingId);

IPC::Message*
Msg_NotifyScreenConfigurationChange(int32_t routingId);

IPC::Message*
Msg_NotifySwitchChange(int32_t routingId);

IPC::Message*
Msg_NotifySystemClockChange(int32_t routingId);

IPC::Message*
Msg_NotifySystemTimezoneChange(int32_t routingId);

IPC::Message*
Msg_Vibrate(int32_t routingId);

IPC::Message*
Msg_CancelVibrate(int32_t routingId);

IPC::Message*
Msg_EnableBatteryNotifications(int32_t routingId);

IPC::Message*
Msg_DisableBatteryNotifications(int32_t routingId);

IPC::Message*
Msg_GetCurrentBatteryInformation(int32_t routingId);
IPC::Message*
Reply_GetCurrentBatteryInformation(int32_t routingId);

IPC::Message*
Msg_EnableNetworkNotifications(int32_t routingId);

IPC::Message*
Msg_DisableNetworkNotifications(int32_t routingId);

IPC::Message*
Msg_GetCurrentNetworkInformation(int32_t routingId);
IPC::Message*
Reply_GetCurrentNetworkInformation(int32_t routingId);

IPC::Message*
Msg_AdjustSystemClock(int32_t routingId);

IPC::Message*
Msg_EnableSystemClockChangeNotifications(int32_t routingId);

IPC::Message*
Msg_DisableSystemClockChangeNotifications(int32_t routingId);

IPC::Message*
Msg_EnableSystemTimezoneChangeNotifications(int32_t routingId);

IPC::Message*
Msg_DisableSystemTimezoneChangeNotifications(int32_t routingId);

IPC::Message*
Msg_ModifyWakeLock(int32_t routingId);

IPC::Message*
Msg_EnableWakeLockNotifications(int32_t routingId);

IPC::Message*
Msg_DisableWakeLockNotifications(int32_t routingId);

IPC::Message*
Msg_GetWakeLockInfo(int32_t routingId);
IPC::Message*
Reply_GetWakeLockInfo(int32_t routingId);

IPC::Message*
Msg_EnableScreenConfigurationNotifications(int32_t routingId);

IPC::Message*
Msg_DisableScreenConfigurationNotifications(int32_t routingId);

IPC::Message*
Msg_LockScreenOrientation(int32_t routingId);
IPC::Message*
Reply_LockScreenOrientation(int32_t routingId);

IPC::Message*
Msg_UnlockScreenOrientation(int32_t routingId);

IPC::Message*
Msg_EnableSwitchNotifications(int32_t routingId);

IPC::Message*
Msg_DisableSwitchNotifications(int32_t routingId);

IPC::Message*
Msg_NotifySensorChange(int32_t routingId);

IPC::Message*
Msg_EnableSensorNotifications(int32_t routingId);

IPC::Message*
Msg_DisableSensorNotifications(int32_t routingId);

IPC::Message*
Msg___delete__(int32_t routingId);
IPC::Message*
Reply___delete__(int32_t routingId);



} // namespace PHal
} // namespace hal_sandbox
} // namespace mozilla

#endif // ifndef PHal_h
